/* gvSIG. Sistema de Informacin Geogrfica de la Generalitat Valenciana
 *
 * Copyright (C) 2006 IVER T.I. and Generalitat Valenciana.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
 */
package org.gvsig.georeferencing.utils;

public class AffineT {
	private int 		order;
	private double[]	xcofs;
	private double[]  	ycofs;
	
	public int getOrder() {
		return order;
	}
	public void setOrder(int order) {
		this.order = order;
	}
	
	public void setCofX(double value, int n){
		xcofs[n] = value;
	}
	
	public void setCofY(double value, int n){
		ycofs[n] = value;
	}
	
	public double getCofX(int n){
		return xcofs[n];
	}
	
	public double getCofY(int n){
		return ycofs[n];
	}
	
	public void setCofX(double[] x){
		this.xcofs = x;
	}
	
	public void setCofY(double[] y){
		this.ycofs = y;
	}
	
	public void mallocCofs(int n){
		xcofs = new double[n];
		ycofs = new double[n];
	}
	
	public double[] getXcofs() {
		return xcofs;
	}
	public double[] getYcofs() {
		return ycofs;
	}
}
